/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006
 
 *Description: 
 *This class is the owner of all award related data. Any GUI that needs any Award information has to 
 *call methods in this class. This class will support returning one specific award, a list of awards or 
 *adding new awards. Currently the class has the possible award values hard coded into it, 
 *which will be changed with the introduction of the database in proto type 2. 
 *The GUI user will never interact with this class.
 */

import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class Award {
	static Calendar cal = new GregorianCalendar();

	static int month = (cal.get(Calendar.MONTH) + 1);

	
	public Award(String awardName, String awardDescription,
			String awardFrequency) throws SQLException {

		String sqlInsert;

		ConnectToDB.createConnection();
		sqlInsert = "Insert INTO [Award] (awardName, awardDescription, awardFrequency) SELECT ('"
				+ awardName + "', '" + awardDescription + "', '" + awardFrequency + "')";

		ConnectToDB.setQuery(sqlInsert);

		ConnectToDB.closeConnection();

	}

	// ---testing
	public static void main(String[] args) throws SQLException {

		// String[] names;
		// names = getAllAwardName();
		// System.out.println("Test: getAllAwardName() \n" + names[0] + "\n"
		// + names[3] + "\n" + names[5]);
		System.out.println("Test: getAwardName(2) - " + getAwardName(2));
		System.out.println("Test: getAwardDescription(getAwardName(2)) - "
				+ getAwardDescription("jdjd"));
		// System.out.println("Test: getAwardDescription(3) - "
		// + getAwardDescription(3));
		System.out.println(getNextAwardDate(2, 3));

	}

	public static String getAwardName(int awardID) throws SQLException {

		String awardName = null;
		String sqlSelect;

		ConnectToDB.createConnection();
		sqlSelect = "SELECT awardName FROM [Award] WHERE awardID = " + awardID;

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			awardName = ConnectToDB.getValue();
		} else {
			awardName = "";
		}

		ConnectToDB.closeConnection();

		return awardName;
	}

	public static int getAwardID(String awardName) throws SQLException {

		int AwardID = 0;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT MAX(awardID) AS lastAwardID FROM [Award] WHERE awardName = '"
				+ awardName + "'";

		ConnectToDB.runQuery(sqlSelect);
		if (ConnectToDB.numberOfRows != 0) {
			AwardID = ConnectToDB.getID();
		} else {
			AwardID = 0;
		}

		ConnectToDB.closeConnection();

		return AwardID;
	}

	public static String getAwardDescription(int awardID) throws SQLException {

		String awardDescription = null;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardDescription FROM [Award] WHERE awardID = "
				+ awardID;

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			awardDescription = ConnectToDB.getValue();
		} else {
			awardDescription = "";
		}

		ConnectToDB.closeConnection();

		return awardDescription;
	}
	
	public static String getAwardDescription(String awardName) throws SQLException {

		int awardID;
		String awardDescription = null;

		awardID = Award.getAwardID(awardName);
		
		awardDescription = getAwardDescription(awardID);
		
		return awardDescription;
	}
	
	public static String getNextAwardDate(int awardID) throws SQLException {
		String awardDate;

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Max([AwardGroupView].[awardDate]) AS CurrentawardDate "
				+ " FROM AwardGroupView " 
				+ " WHERE awardID = " + awardID
				+ " AND awardMonth = " + month;
		
		ConnectToDB.runQuery(sqlSelect);
		if (ConnectToDB.numberOfRows != 0) {
			awardDate = ConnectToDB.getValue();
			awardDate = awardDate.substring(0,10);
			//'2006-12-01'

			String awardYear = awardDate.substring(0,4);
			String awardMonth = awardDate.substring(5, 7);
			String awardDay = awardDate.substring(8,10);
			
			awardDate = awardMonth + '/' + awardDay + '/' + awardYear;

		} else {
			awardDate = "01/01/1900";
		}
				
		ConnectToDB.closeConnection();

		return awardDate;
	}	
	
	public static String getNextAwardDate() throws SQLException {
		String awardDate;

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Max([AwardGroupView].[awardDate]) AS CurrentawardDate "
				+ " FROM AwardGroupView " ;
		
		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			awardDate = ConnectToDB.getValue();
			awardDate = awardDate.substring(0,10);
			//'2006-12-01'

			String awardYear = awardDate.substring(0,4);
			String awardMonth = awardDate.substring(5, 7);
			String awardDay = awardDate.substring(8,10);
			
			awardDate = awardMonth + '/' + awardDay + '/' + awardYear;

		} else {
			awardDate = "01/01/1900";
		}
		
		ConnectToDB.closeConnection();

		return awardDate;
	}	
	
	public static String getNextAwardDate(int awardID, int groupID) throws SQLException {
		String awardDate;

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Max([AwardGroupView].[awardDate]) AS CurrentawardDate "
				+ " FROM AwardGroupView " 
				+ " WHERE awardID = " + awardID
				+ " AND groupID = " + groupID
				+ " AND awardMonth = " + month;
		
		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			awardDate = ConnectToDB.getValue();
			awardDate = awardDate.substring(0,10);
			//'2006-12-01'

			String awardYear = awardDate.substring(0,4);
			String awardMonth = awardDate.substring(5, 7);
			String awardDay = awardDate.substring(8,10);
			
			awardDate = awardMonth + '/' + awardDay + '/' + awardYear;

		} else {
			awardDate = "01/01/1900";
		}
		
		ConnectToDB.closeConnection();

		return awardDate;
	}

	public static String getNextAwardDate(String awardName, String groupName) throws SQLException {
		
		int awardID = Award.getAwardID(awardName);
		int groupID = Group.getGroupID(groupName);

		String awardDate = getNextAwardDate (awardID, groupID);
		
		return awardDate;
	}


	public static String getNextAwardDate(String awardName) throws SQLException {
		
		int awardID = Award.getAwardID(awardName);
		
		String awardDate = getNextAwardDate (awardID);
		
		return awardDate;
	}

	public static String[] getAllAwardName() throws SQLException {

		String sqlSelect;

		ConnectToDB.createConnection();
		String[] awardNameList; 
		sqlSelect = "SELECT awardName FROM [Award] ORDER BY awardName";

		ConnectToDB.runQuery(sqlSelect);
		int recordCount = ConnectToDB.numberOfRows;
		if (recordCount != 0) {
			String[] tempAwardNameList  = new String[recordCount];
			tempAwardNameList = ConnectToDB.getList();
	
			awardNameList = new String[recordCount + 1];
			awardNameList[0] = "<Please select>";
			
			int i = 0;
			while (i <  recordCount) {
				awardNameList[i + 1] = tempAwardNameList[i];
				i++;
			}
		}
		else {
			awardNameList  = new String[1];
			awardNameList[0] = "";
		}
		ConnectToDB.closeConnection();

		return awardNameList;
	}

	public static String[] getAllGroupAwardName(String groupName) throws SQLException {

		String sqlSelect;
		int groupID = Group.getGroupID(groupName);
		String awardDate = Award.getNextAwardDate();
		String[] awardNameList; 
		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardName FROM [AwardGroupView]"
			+ " WHERE groupID = " + groupID
			+ " AND awardDate = #" + awardDate + "#"
			+ " ORDER BY awardName";

		ConnectToDB.runQuery(sqlSelect);
		int recordCount = ConnectToDB.numberOfRows;
		if (recordCount != 0) {
			String[] tempAwardNameList  = new String[recordCount];
			tempAwardNameList = ConnectToDB.getList();
			
			awardNameList = new String[recordCount + 1];
			awardNameList[0] = "<Please select>";
			
			int i = 0;
			while (i < recordCount) {
				awardNameList[i + 1] = tempAwardNameList[i];
				i++;
			}
		}
		else {
			awardNameList  = new String[1];
			awardNameList[0] = "";
		}
		ConnectToDB.closeConnection();

		return awardNameList;
	}
}
