/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006
 
 *Description: 
 *This class is the owner of all employee related data. Any GUI that needs any Employee information 
 *has to call methods in this class. This class will support returning one specific Employee 
 *information, or a list of all employees. This class does not and will not support adding new 
 *Employees into the solution. That will be managed by the database in the future. Currently the 
 *class has the possible employee names hard coded into it, which will be changed with the introduction 
 *of the database in proto type 2. The GUI user does not interact with this class directly.	
 */

import java.sql.SQLException;

public class Employee {

	// ---testing
	public static void main(String[] args) throws SQLException {

//		// ---Testing the get name
//		String name = getEmpName(7);
//		System.out.println(name);
//
//		// ---Testing Nomination getNomination returning values to Result
//		Nomination.getNomination("Employee of the Month", name);
//		ConnectToDB.resultSet.beforeFirst();
//		while (ConnectToDB.resultSet.next()) {
//			System.out.println(ConnectToDB.resultSet.getString(1));
//			System.out.println(ConnectToDB.resultSet.getDate(2));
//			System.out.println(ConnectToDB.resultSet.getString(3));
//			System.out.println(ConnectToDB.resultSet.getString(4));
//		}
//
//		// ---Testing Nomination getNomination returning values to JTable
//		Nomination.getNomination("Seven Attributes - Curious");
//		ConnectToDB.resultSet.beforeFirst();
//		while (ConnectToDB.resultSet.next()) {
//			System.out.println(ConnectToDB.resultSet.getString(1));
//			System.out.println(ConnectToDB.resultSet.getDate(2));
//			System.out.println(ConnectToDB.resultSet.getString(3));
//			System.out.println(ConnectToDB.resultSet.getString(4));
//		}
//
//		// ---Test Nomination getNominationEmpName
//		String[] nomNames = Nomination
//				.getNominationEmpName("Employee of the Month");
//		System.out.println(nomNames[0]);
//
//		// ---Test adding a new Nomination list string
//		String awardName, groupName, nominatedEmpName, nominationByEmpName, nominationComment;
//
//		awardName = "Seven Attributes - Smart";
//		groupName = "Operations";
//		nominatedEmpName = "Arnold, Vicki D.";
//		nominationByEmpName = "Bays, Max J.";
//		nominationComment = "insert from the employee class";
//		System.out.println("Starting");
//		new Nomination(awardName, groupName, nominatedEmpName,
//				nominationByEmpName, nominationComment);
//
//		// --- Test Nomination getNominationEmpName
		String[] nomNames3 = Nomination
				.getNominationEmpName("ASDS");
		System.out.println(nomNames3[0]);
//
//		// --- Test Nomination getNominationEmpName
//		String[] nomAward = Award
//				.getAllAwardName();
//		System.out.println(nomAward[0]);
//		
		System.out.println(getUserNameEmpName("najami"));
	}

	public static String getEmpName(int empID) throws SQLException {

		String empName = null;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empLastName + ', ' + Employee.empFirstName as empName FROM [Employee] WHERE empID = "
				+ empID;

		ConnectToDB.runQuery(sqlSelect);
		
		if (ConnectToDB.numberOfRows != 0) {
			empName = ConnectToDB.getValue();
		} else {
			empName = "";
		}


		ConnectToDB.closeConnection();

		return empName;
	}

	public static int getEmpID(String empName) throws SQLException {

		int empID = 0;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empID FROM [Employee] WHERE Employee.empLastName + ', ' + Employee.empFirstName = '"
				+ empName + "'";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			empID = ConnectToDB.getID();
		} else {
			empID = 0;
		}

		ConnectToDB.closeConnection();

		return empID;
	}

	public static String getUserNameEmpName(String userName) throws SQLException {

		String empName = null;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empLastName + ', ' + Employee.empFirstName as empName"
				+ " FROM [Employee] " 
				+ " WHERE Employee.empUserName = '" + userName + "'";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			empName = ConnectToDB.getValue();
		} else {
			empName = "";
		}

		ConnectToDB.closeConnection();

		return empName;
	}
	
	public static boolean checkLogin(String empUserName, char[] empPassword)
			throws SQLException {

		String empName = null;
		String empPasswordString = "";
		String sqlSelect;

		for (int i = 0; i < empPassword.length; i++) {
			empPasswordString = empPasswordString + empPassword[i];
		}

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empLastName + ', ' + Employee.empFirstName as empName FROM [Employee] WHERE empUserName = '"
				+ empUserName
				+ "' AND empPassword = '"
				+ empPasswordString
				+ "'";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			empName = ConnectToDB.getValue();
		} else {
			empName = null;
		}

		ConnectToDB.closeConnection();

		if (empName != null) {
			return true;
		} else {
			return false;
		}
	}

	public static String[] getAllName() throws SQLException {

		String sqlSelect;
		String[] NameList; 

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empLastName + ', ' + Employee.empFirstName as empName FROM [Employee]";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			NameList = new String[ConnectToDB.numberOfRows + 1];
			NameList = ConnectToDB.getList();
		} else {
			NameList = new String[1];
			NameList[0]  = "";
		}
		
		ConnectToDB.closeConnection();

		return NameList;

	}

	public static String[] getGroupAllName(String groupName) throws SQLException {

		int groupID = Group.getGroupID(groupName);
		
		String sqlSelect;
		String[] NameList;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT Employee.empLastName + ', ' + Employee.empFirstName as empName "
				+ " FROM [Employee]"
				+ " WHERE groupID = " + groupID;

		ConnectToDB.runQuery(sqlSelect);
		int recordCount  = ConnectToDB.numberOfRows;
		if (recordCount != 0) {
			String[] tempNameList = new String[recordCount];
			tempNameList = ConnectToDB.getList();
	
			NameList = new String[recordCount + 1];
			NameList[0] = "Please select < lastname, firstname >";
			
			int i = 0;
			while (i <  recordCount) {
				NameList[i + 1] = tempNameList[i];
				i++;
			}
		}
		else {
			NameList  = new String[1];
			NameList[0] = "Please select <lastname, firstname>";
		}

		
		ConnectToDB.closeConnection();

		return NameList;

	}
}
