import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * @Author: Diana Mei Leng Wong Michiko Chand Nazih Ajami
 * @Date: November 15, 2006
 * 
 * Description:
 * 
 */


public class Nomination {

	static Calendar cal = new GregorianCalendar();

	private static int year = cal.get(Calendar.YEAR);

	private static int month = cal.get(Calendar.MONTH) + 1;

	private static int day = cal.get(Calendar.DAY_OF_MONTH);
	
	private static String date = (String) ("" + month + "/" + day + "/" + year);
	
	static ResultSet rsNom = null;
	
	// ---testing
	public static void main(String[] args) throws SQLException {

		getNomination("Employee of the Month");
		new Nomination(1, 1, 7, 40, "He is Good");
	}
	
	public  Nomination(int awardID, int groupID, int nominatedEmpID,
			int nominationByEmpID, String nominationComment)
			throws SQLException {

		String sqlInsert;

		String awardDate = Award.getNextAwardDate(awardID, groupID);
		
		ConnectToDB.createConnection();

		sqlInsert = "Insert INTO [Nomination](awardID, groupID, awardDate, nominatedEmpID, nominationByEmpID, nominationDate, nominationComment)"
				+ " SELECT "
				+ awardID
				+ ", "
				+ groupID
				+ ", '"
				+ awardDate
				+ "', "
				+ nominatedEmpID
				+ ", "
				+ nominationByEmpID
				+ ", '"
				+ date
				+ "', '"
				+ nominationComment + "'";

		System.out.println(sqlInsert);
		
		ConnectToDB.setQuery(sqlInsert);

		System.out.println("Done");

		ConnectToDB.closeConnection();
	}

	public Nomination(String awardName, String groupName,
			String nominatedEmpName, String nominationByEmpName,
			String nominationComment) throws SQLException {

		int groupID = Group.getGroupID(groupName);
		int awardID = Award.getAwardID(awardName);
		int nominatedEmpID = Employee.getEmpID(nominatedEmpName);
		int nominationByEmpID = Employee.getEmpID(nominationByEmpName);

		new Nomination(awardID, groupID, nominatedEmpID, nominationByEmpID,
				nominationComment);
	}

	public static void getNomination(String awardName) throws SQLException {

		String sqlSelect;
		
		String awardDate = Award.getNextAwardDate(awardName);

		ConnectToDB.createConnection();

		sqlSelect = "SELECT nominatedName, nominationDate, nominationComment, nominatedByName "
				+ " FROM [NominationInfo] "
				+ " WHERE awardName = '" + awardName + "'"
				+ " AND awardDate >= #" + awardDate + "#"
				+ " ORDER BY NominationInfo.nominatedName, NominationInfo.nominationDate";

		ConnectToDB.runQuery(sqlSelect);

		rsNom = ConnectToDB.resultSet;

	}

	public static void getNomination(String awardName, String nominatedName) throws SQLException {

	String sqlSelect;

	String awardDate = Award.getNextAwardDate(awardName);
	
	ConnectToDB.createConnection();
	
	sqlSelect = "SELECT NominationInfo.nominatedName, NominationInfo.nominationDate, NominationInfo.nominationComment, NominationInfo.nominatedByName "
			+ " FROM [NominationInfo] "
			+ " WHERE awardName = '" + awardName + "'"
			+ " AND nominatedName = '" + nominatedName + "'"
			+ " AND awardDate >= #" + awardDate + "#"
			+ " ORDER BY NominationInfo.nominatedName, NominationInfo.nominationDate";
	
	ConnectToDB.runQuery(sqlSelect);

	rsNom = ConnectToDB.resultSet;
	}

	
	public static void getGroupNomination(String awardName, String groupName) throws SQLException {

		String sqlSelect;

		String awardDate = Award.getNextAwardDate(awardName);

		ConnectToDB.createConnection();

		sqlSelect = "SELECT nominatedName, nominationDate, nominationComment, nominatedByName "
				+ " FROM [NominationInfo] "
				+ " WHERE awardName = '" + awardName + "'" 
				+ " AND groupName = '" + groupName + "'"
				+ " AND awardDate >= #" + awardDate + "#"
				+ " ORDER BY NominationInfo.nominatedName, NominationInfo.nominationDate";
		
		ConnectToDB.runQuery(sqlSelect);

		rsNom = ConnectToDB.resultSet;

	}


	public static void getGroupNomination(String awardName, String groupName, String nominatedName) throws SQLException {

		String sqlSelect;

		String awardDate = Award.getNextAwardDate(awardName, groupName);
		
		ConnectToDB.createConnection();

		sqlSelect = "SELECT nominatedName, nominationDate, nominationComment, nominatedByName "
				+ " FROM [NominationInfo] "
				+ " WHERE awardName = '" + awardName + "'"
				+ " AND groupName = '" + groupName + "'"
				+ " AND nominatedName = '" + nominatedName + "'"
				+ " AND awardDate >= #" + awardDate + "#"
				+ " ORDER BY NominationInfo.nominatedName, NominationInfo.nominationDate";
		
		ConnectToDB.runQuery(sqlSelect);

		rsNom = ConnectToDB.resultSet;

	}

	public static String[] getNominationEmpName(String awardName)
			throws SQLException {

		String sqlSelect;

		String awardDate = Award.getNextAwardDate(awardName);

		String[] NominatedList;
		
		ConnectToDB.createConnection();

		sqlSelect = "SELECT DISTINCT nominatedName "
				+ " FROM [NominationInfo] " 
				+ " WHERE awardName = '" + awardName + "'"
				+ " AND awardDate >= #" + awardDate + "#"
				+ " ORDER BY nominatedName ";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			NominatedList = new String[ConnectToDB.numberOfRows + 1];
			NominatedList = ConnectToDB.getList();
		} else {
			NominatedList = new String[1];
			NominatedList[0]  = "";
		}
		
		ConnectToDB.closeConnection();

		return NominatedList;
	}

	public static String[] getGroupNominationEmpName(String awardName, String groupName)
			throws SQLException {

		String sqlSelect;

		String awardDate = Award.getNextAwardDate(awardName);

		String[] NominatedList;
		
		ConnectToDB.createConnection();

		sqlSelect = "SELECT DISTINCT nominatedName "
				+ " FROM [NominationInfo] " 
				+ " WHERE awardName = '" + awardName + "'"
				+ " AND groupName = '" + groupName + "'"
				+ " AND awardDate >= #" + awardDate + "#"
				+ " ORDER BY nominatedName ";

		ConnectToDB.runQuery(sqlSelect);

		if (ConnectToDB.numberOfRows != 0) {
			NominatedList = new String[ConnectToDB.numberOfRows + 1];
			NominatedList = ConnectToDB.getList();
		} else {
			NominatedList = new String[1];
			NominatedList[0]  = "";
		}

		ConnectToDB.closeConnection();

		return NominatedList;
	}

}
