import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

public class ReportGUI {
	
	JFrame mainWindow;

	JPanel dialogPane = new JPanel();
	
	JPanel logoPanel = new JPanel();
	
	JPanel contentPanel = new JPanel();
	
	JPanel reportPane = new JPanel();
	
	JLabel searchFieldLabel = new JLabel();
	
	JLabel searchbyLabel = new JLabel();

	JPanel buttonBar = new JPanel();
	
	JPanel buttonBar2 = new JPanel();
	
	JButton reportButton = new JButton();
	
	JButton printButton = new JButton();
	
	JButton okButton = new JButton();
	
	JScrollPane scrollPane = new JScrollPane();
	
	String[] search = { "<Please select>                       				", "Employee Name",
			"Manager Name", "Award Name" };

	JComboBox searchByCBox = new JComboBox(search);

	String searchBy = (String) searchByCBox.getSelectedItem();

	String[] searchField = { "<Please select>                        				" };

	JComboBox searchFieldCBox = new JComboBox(searchField);

	String[] columnNames = { "Group Name", "Employee Name", "Award Name",
			"Date Received" };

	Object[][] data = { { "", "", "", "" }, { "", "", "", "" },
					  { "", "", "", "" }, { "", "", "", "" }, { "", "", "", "" }, 
					  { "", "", "", "" }, { "", "", "", "" }, { "", "", "", "" }, 
					  { "", "", "", "" }, { "", "", "", "" }, { "", "", "", "" }, 
					  { "", "", "", "" }, { "", "", "", "" }, { "", "", "", "" } };

	JTable reportsTable = new JTable(data, columnNames);

	Vector rows = new Vector();

	Vector columns;

	DefaultTableModel tabModel;

	int rowCount;

	int rowNumber;

	private static final long serialVersionUID = 1L;

	public void setRow(int row) {
		rowNumber = row;
		System.out.println("Set Row " + rowNumber);
	}

	public int getRow() {
		System.out.println("get Row " + rowNumber);
		return rowNumber;
	}

	public static void main(String args[]) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new ReportGUI();
			}
		});
	}

	public ReportGUI() {
		
		// ======== mainWindowFrame ========
		mainWindow = new JFrame();
		mainWindow.setTitle("Reports");
		mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainWindow.setLocation(300, 100);

		dialogPane.setLayout(new BorderLayout());
		dialogPane.setPreferredSize(new Dimension(600, 600));
		mainWindow.setContentPane(dialogPane);

		//======== dialogPane ========
		{
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));

			dialogPane.setBorder(new javax.swing.border.CompoundBorder(
				new javax.swing.border.TitledBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0),
					"", javax.swing.border.TitledBorder.CENTER,
					javax.swing.border.TitledBorder.BOTTOM, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12),
					java.awt.Color.red), dialogPane.getBorder())); dialogPane.addPropertyChangeListener(new java.beans.PropertyChangeListener(){public void propertyChange(java.beans.PropertyChangeEvent e){if("border".equals(e.getPropertyName()))throw new RuntimeException();}});

			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new GridBagLayout());
				((GridBagLayout)contentPanel.getLayout()).columnWidths = new int[] {0, 0};
				((GridBagLayout)contentPanel.getLayout()).rowHeights = new int[] {15, 0, 0};
				((GridBagLayout)contentPanel.getLayout()).columnWeights = new double[] {1.0, 1.0E-4};
				((GridBagLayout)contentPanel.getLayout()).rowWeights = new double[] {0.0, 1.0, 1.0E-4};

				//======== logoPanel ========
				{
					logoPanel.setLayout(new GridBagLayout());
					((GridBagLayout)logoPanel.getLayout()).columnWidths = new int[] {0, 0, 0, 0};
					((GridBagLayout)logoPanel.getLayout()).rowHeights = new int[] {0, 0};
					((GridBagLayout)logoPanel.getLayout()).columnWeights = new double[] {1.0, 0.0, 0.0, 1.0E-4};
					((GridBagLayout)logoPanel.getLayout()).rowWeights = new double[] {0.0, 1.0E-4};

					//---- logoLabel ----
					DrawLogo northLogoPanel = new DrawLogo();
					logoPanel.add(northLogoPanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 30, 5), 300, 100));
				}
				contentPanel.add(logoPanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 20, 5, 0), 0, 0));

				//======== reportPane ========
				{
					reportPane.setLayout(new GridBagLayout());
					((GridBagLayout)reportPane.getLayout()).columnWidths = new int[] {0, 0, 0, 0, 0};
					((GridBagLayout)reportPane.getLayout()).rowHeights = new int[] {0, 0, 0, 0, 0};
					((GridBagLayout)reportPane.getLayout()).columnWeights = new double[] {1.0, 0.0, 0.0, 1.0, 1.0E-4};
					((GridBagLayout)reportPane.getLayout()).rowWeights = new double[] {0.0, 0.0, 0.0, 1.0, 1.0E-4};

					//---- searchbyLabel ----
					searchbyLabel.setText("Search By:");
					reportPane.add(searchbyLabel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 40), 0, 0));
					searchByCBox.addActionListener(new SearchByList());
					reportPane.add(searchByCBox, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 40), 0, 0));

					//---- searchFieldLabel ----
					searchFieldLabel.setText("Search Field:");
					reportPane.add(searchFieldLabel, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 40), 0, 0));
					reportPane.add(searchFieldCBox, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 40), 0, 0));
		
					//======== buttonBar2 ========
					{
						buttonBar2.setBorder(new EmptyBorder(12, 0, 0, 0));
						buttonBar2.setLayout(new GridBagLayout());
						((GridBagLayout)buttonBar2.getLayout()).columnWidths = new int[] {80};

						//---- reportButton ----
						reportButton.setText("Generate Report");
						reportButton.addActionListener(new ReportGenerate());
						buttonBar2.add(reportButton, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
							GridBagConstraints.CENTER, GridBagConstraints.BOTH,
							new Insets(0, 0, 10, 0), 0, 0));
					}
					reportPane.add(buttonBar2, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 40), 0, 0));
		
		
					//======== adding table ========
					tabModel=new DefaultTableModel();
					columns = new Vector();
					for(int i=0;i<columnNames.length;i++){
					columns.addElement((String) columnNames[i]);
					}
					tabModel.setDataVector(rows,columns);
					reportsTable = new JTable(tabModel);
					reportsTable.setRowSelectionAllowed(false);
					
					//======== scrollPane ========
					{
						scrollPane.setViewportView(reportsTable);
					}
					reportPane.add(scrollPane, new GridBagConstraints(0, 3, 4, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 0, 0), 0, 0));
				}
				contentPanel.add(reportPane, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 30, 0, 30), 0, 0));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(new EmptyBorder(12, 0, 0, 0));
				buttonBar.setLayout(new GridBagLayout());
				((GridBagLayout)buttonBar.getLayout()).columnWidths = new int[] {85, 80};

				//---- printButton ----
				printButton.setText("Print");
				buttonBar.add(printButton, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 5), 0, 0));

				//---- okButton ----
				okButton.setText("Done");
				okButton.addActionListener(new ExitPage());
				buttonBar.add(okButton, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		
		//		 ---- pack the window and display it ----
		mainWindow.pack();
		mainWindow.setVisible(true);
	}

	class ExitPage implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			mainWindow.dispose();
			new SwitchBoard();
		}

	}

	class SearchByList implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			String selectedSearch = (String) searchByCBox.getSelectedItem();
			try {
				if (selectedSearch == "Employee Name") {
					searchField = Employee.getAllName();
					searchFieldCBox.removeAllItems();
					for (int j = 0; j < searchField.length; j++) {
						searchFieldCBox.addItem(searchField[j]);
					}
				} else {
					if (selectedSearch == "Manager Name") {
						searchField = Employee.getAllName();
						searchFieldCBox.removeAllItems();
						for (int j = 0; j < searchField.length; j++) {
							searchFieldCBox.addItem(searchField[j]);
						}
					} else {
						if (selectedSearch == "Award Name") {
							searchField = Award.getAllAwardName();
							searchFieldCBox.removeAllItems();
							for (int j = 0; j < searchField.length; j++) {
								searchFieldCBox.addItem(searchField[j]);
							}
						} else {
							searchFieldCBox.removeAllItems();
							searchFieldCBox
									.addItem("<Please select>");
						}
					}

				}
			} catch (SQLException e1) {
				e1.printStackTrace();
			}
		}
	}

	class ReportGenerate implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			try {
				String selectedSearch = (String) searchByCBox.getSelectedItem();
				if (selectedSearch == "Employee Name") {
					String selectedField = (String) searchFieldCBox
							.getSelectedItem();
					Report.searchEmployee(selectedField);
					dataDisplay();
				} else {
					if (selectedSearch == "Manager Name") {
						String selectedField = (String) searchFieldCBox
								.getSelectedItem();
						Report.searchManager(selectedField);
						dataDisplay();
					} else {
						if (selectedSearch == "Award Name") {
							String selectedField = (String) searchFieldCBox
									.getSelectedItem();
							Report.searchAward(selectedField);
							dataDisplay();
						} else {

						}
					}
				}
			} catch (SQLException e1) {
				e1.printStackTrace();
			}
		}

	}

	public void dataDisplay() {
		try {
			rowCount = getRow();
			if (rowCount == 0) {

			} else {
				rowDeletion(rowCount);
			}
			ResultSet rs = Report.rsNom;
			int row = 0;
			rs.beforeFirst();
			while (rs.next()) {
				Vector t = new Vector();
				t.addElement((String) " ");
				t.addElement((String) " ");
				t.addElement((String) " ");
				t.addElement((String) " ");
				rows.addElement(t);
				reportsTable.addNotify();
				reportsTable.setValueAt(rs.getString(1), row, 0);
				reportsTable.setValueAt(rs.getString(2), row, 1);
				reportsTable.setValueAt(rs.getString(3), row, 2);
				reportsTable.setValueAt(rs.getDate(4), row, 3);
				row++;
			}
			System.out.println("row = " + row);
			setRow(row);
		} catch (SQLException e1) {
			e1.printStackTrace();
		}
	}

	public void rowDeletion(int rowno) {
		int rowCount = rowno - 1;
		System.out.println("Row Count is " + rowCount);
		for (int i = rowCount; i >= 0; i--) {
			System.out.println("i = " + i);
			rows.removeElementAt(i);
			reportsTable.addNotify();
		}
	}
}
