/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006

 *Description: 
 *This class creates the GUI which helps mangers (users with access) to vote for winners based on a 
 *list of employees nominated for awards. This class currently calls methods in the employee class and 
 *in the award class. In prototype 2 this class will call the Vote class to add the managers vote 
 *into the solution. Currently the class hard codes values out of what should be the nomination class. 
 *For prototype 2 the class will also call the Nomination class.
 */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

public class guiVoteForWinner {

	JFrame mainWindow;

	JTextArea awardDesText = new JTextArea(200, 20);

	JTextField dateText = new JTextField(20);

	JPanel dialogPane = new JPanel();

	String[] awardList = Award.getAllAwardName();

	String[] employeeList = Employee.getAllName();

	String[] groupList = Group.getAllGroupName();

	JComboBox awardListCBox = new JComboBox(awardList);

	String awardName = null;

	String EmpUserName;

	JComboBox voteListCBox = new JComboBox();

	JComboBox groupListCBox = new JComboBox(groupList);

	protected JTable commentTable;

	Vector rows = new Vector();

	Vector columns;

	DefaultTableModel tabModel;

	int rowCount;

	int rowNumber;

	private static final long serialVersionUID = 1L;

	String[] columnNames = { "Nominees", "Date", "Comments", "Nominated By" };

	Object[][] data = { { "", "", "", "" }, { "", "", "", "" },
			{ "", "", "", "" }, { "", "", "", "" }, { "", "", "", "" } };

	public void setRow(int row) {
		rowNumber = row;
		System.out.println("Set Row " + rowNumber);
	}

	public int getRow() {
		System.out.println("get Row " + rowNumber);
		return rowNumber;
	}

	public static void main(String args[]) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					new guiVoteForWinner("najami");
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		});
	}

	public guiVoteForWinner(String username) throws SQLException {

		EmpUserName = username;
		// ======== mainWindowFrame ========
		mainWindow = new JFrame();
		mainWindow.setTitle("Vote For Winner");
		mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainWindow.setLocation(300, 100);

		dialogPane.setLayout(new BorderLayout());
		dialogPane.setPreferredSize(new Dimension(600, 600));
		mainWindow.setContentPane(dialogPane);

		JPanel dataGrid = new JPanel();
		JPanel contentPanel = new JPanel();
		JPanel logoPanel = new JPanel();
		JPanel votePanel = new JPanel();
		JLabel groupLabel = new JLabel();
		JLabel awardNamelabel = new JLabel();
		JLabel awardDeslabel = new JLabel();
		JLabel dateLabel = new JLabel();
		JScrollPane scrollPane1 = new JScrollPane(awardDesText,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		JLabel votelabel = new JLabel();
		JPanel buttonBar = new JPanel();
		JButton submitButton = new JButton();
		JButton cancelButton = new JButton();
		JButton logOutButton = new JButton();
		JScrollPane scrollPane2 = new JScrollPane();

		// ======== dialogPane ========
		{
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));

			dialogPane
					.setBorder(new javax.swing.border.CompoundBorder(
							new javax.swing.border.TitledBorder(
									new javax.swing.border.EmptyBorder(0, 0, 0,
											0), "",
									javax.swing.border.TitledBorder.CENTER,
									javax.swing.border.TitledBorder.BOTTOM,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									java.awt.Color.red), dialogPane.getBorder()));
			dialogPane
					.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
						public void propertyChange(
								java.beans.PropertyChangeEvent e) {
							if ("border".equals(e.getPropertyName()))
								throw new RuntimeException();
						}
					});

			dialogPane.setLayout(new BorderLayout());

			// ======== contentPanel ========
			{
				contentPanel.setLayout(new GridBagLayout());
				((GridBagLayout) contentPanel.getLayout()).columnWidths = new int[] {
						0, 0 };
				((GridBagLayout) contentPanel.getLayout()).rowHeights = new int[] {
						20, 0, 0 };
				((GridBagLayout) contentPanel.getLayout()).columnWeights = new double[] {
						1.0, 1.0E-4 };
				((GridBagLayout) contentPanel.getLayout()).rowWeights = new double[] {
						0.0, 0.0, 1.0E-4 };

				// ======== logoPanel ========
				{
					logoPanel.setLayout(new GridBagLayout());
					((GridBagLayout) logoPanel.getLayout()).columnWidths = new int[] {
							0, 0, 0, 0 };
					((GridBagLayout) logoPanel.getLayout()).rowHeights = new int[] {
							102, 0 };
					((GridBagLayout) logoPanel.getLayout()).columnWeights = new double[] {
							0.0, 0.0, 0.0, 1.0E-4 };
					((GridBagLayout) logoPanel.getLayout()).rowWeights = new double[] {
							0.0, 1.0E-4 };

					DrawLogo northLogoPanel = new DrawLogo();
					logoPanel.add(northLogoPanel, new GridBagConstraints(0, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 30, 5),
							300, 100));
				}
				contentPanel.add(logoPanel,
						new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
								GridBagConstraints.CENTER,
								GridBagConstraints.BOTH, new Insets(0, 20, 10,
										0), 0, 0));

				// ======== votePanel ========
				{
					votePanel.setLayout(new GridBagLayout());
					((GridBagLayout) votePanel.getLayout()).columnWidths = new int[] {
							0, 70, 0, 0 };
					((GridBagLayout) votePanel.getLayout()).rowHeights = new int[] {
							0, 0, 0, 80, 111, 0, 0 };
					((GridBagLayout) votePanel.getLayout()).columnWeights = new double[] {
							0.0, 0.0, 1.0, 1.0E-4 };
					((GridBagLayout) votePanel.getLayout()).rowWeights = new double[] {
							0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 1.0E-4 };

					// ---- groupLabel ----
					groupLabel.setText("Group Name:");
					votePanel.add(groupLabel, new GridBagConstraints(0, 0, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));
					groupListCBox.addActionListener(new groupList());
					votePanel.add(groupListCBox, new GridBagConstraints(1, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));

					// ---- awardNamelabel ----
					awardNamelabel.setText("Award Name:");
					votePanel.add(awardNamelabel, new GridBagConstraints(0, 1,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));
					awardListCBox.addActionListener(new awardList());
					votePanel.add(awardListCBox, new GridBagConstraints(1, 1,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));

					// ---- dateLabel ----
					dateLabel.setText("Award Period:");
					votePanel.add(dateLabel, new GridBagConstraints(0, 2, 1, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));

					// ---- dateText ----
					dateText.setEditable(false);
					dateText.setBackground(SystemColor.controlHighlight);
					votePanel.add(dateText, new GridBagConstraints(1, 2, 1, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));

					// ---- awardDeslabel ----
					awardDeslabel.setText("Award Description:");
					votePanel.add(awardDeslabel, new GridBagConstraints(0, 3,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 40),
							0, 0));

					// ======== scrollPane1 ========
					{

						// ---- awardDesText ----
						awardDesText.setEditable(false);
						awardDesText.setLineWrap(true);
						awardDesText.setWrapStyleWord(true);
						scrollPane1.setViewportView(awardDesText);

					}
					votePanel.add(scrollPane1, new GridBagConstraints(1, 3, 2,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 0),
							0, 0));

					// ======== dataGrid ========
					{
						dataGrid.setLayout(new GridBagLayout());
						((GridBagLayout) dataGrid.getLayout()).columnWidths = new int[] {
								0, 0 };
						((GridBagLayout) dataGrid.getLayout()).rowHeights = new int[] {
								100, 0 };
						((GridBagLayout) dataGrid.getLayout()).columnWeights = new double[] {
								1.0, 1.0E-4 };
						((GridBagLayout) dataGrid.getLayout()).rowWeights = new double[] {
								1.0, 1.0E-4 };

						// ======== scrollPane2 ========
						{

							// ---- commentTable ----
							tabModel = new DefaultTableModel();
							columns = new Vector();
							for (int i = 0; i < columnNames.length; i++) {
								columns.addElement((String) columnNames[i]);
							}
							tabModel.setDataVector(rows, columns);
							commentTable = new JTable(tabModel);
							commentTable.setRowSelectionAllowed(false);
							scrollPane2.setViewportView(commentTable);
						}
						dataGrid.add(scrollPane2, new GridBagConstraints(0, 0,
								1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
								GridBagConstraints.BOTH,
								new Insets(0, 0, 0, 0), 0, 0));
					}
					votePanel.add(dataGrid, new GridBagConstraints(0, 4, 3, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 0),
							0, 0));

					// ---- votelabel ----
					votelabel.setText("Pick Your Winner:");
					votePanel.add(votelabel, new GridBagConstraints(0, 5, 1, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 40),
							0, 0));
					voteListCBox
							.addItem("Please select < lastname, firstname >");
					votePanel.add(voteListCBox, new GridBagConstraints(1, 5, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 40),
							0, 0));
				}
				contentPanel.add(votePanel,
						new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
								GridBagConstraints.CENTER,
								GridBagConstraints.BOTH, new Insets(0, 30, 0,
										30), 0, 0));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			// ======== buttonBar ========
			{
				buttonBar.setBorder(new EmptyBorder(12, 0, 0, 0));
				buttonBar.setLayout(new GridBagLayout());
				((GridBagLayout) buttonBar.getLayout()).columnWidths = new int[] {
						0, 85, 80 };
				((GridBagLayout) buttonBar.getLayout()).rowWeights = new double[] { 1.0 };

				// ---- submitButton ----
				submitButton.setText("Submit");
				submitButton.setToolTipText("Submit");
				submitButton.addActionListener(new ClickSubmit());
				buttonBar.add(submitButton, new GridBagConstraints(0, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));

				// ---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.setToolTipText("Cancel");
				cancelButton.addActionListener(new ClickCancel());
				buttonBar.add(cancelButton, new GridBagConstraints(1, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));

				// ---- logOutButton ----
				logOutButton.setText("Log-Out");
				logOutButton.setToolTipText("Log-out");
				logOutButton.addActionListener(new ClickExit());
				buttonBar.add(logOutButton, new GridBagConstraints(2, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}

		// ---- pack the window and display it ----
		mainWindow.pack();
		mainWindow.setVisible(true);

	}

	class groupList implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			String selectedGroup = (String) groupListCBox.getSelectedItem();
			try {
				awardList = Award.getAllGroupAwardName(selectedGroup);
				awardListCBox.removeAllItems();
				for (int j = 0; j < awardList.length; j++) {
					awardListCBox.addItem(awardList[j]);
				}

			} catch (SQLException e3) {
				e3.printStackTrace();
			}

		}
	}

	class awardList implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			String selectedAward = (String) awardListCBox.getSelectedItem();
			String selectedGroup = (String) groupListCBox.getSelectedItem();
			try {
				if (selectedAward == "<Please select>") {

				} else {
					awardDesText.setText(Award
							.getAwardDescription(selectedAward));
					dateText.setText(Award.getNextAwardDate());
				}

				String[] NominatedList = Nomination.getGroupNominationEmpName(
						selectedAward, selectedGroup);

				voteListCBox.removeAllItems();
				voteListCBox.addItem("Please select < lastname, firstname >");
				for (int j = 0; j < NominatedList.length; j++) {
					voteListCBox.addItem(NominatedList[j]);
				}
				Nomination.getGroupNomination(selectedAward, selectedGroup);
				rowCount = getRow();
				if (rowCount == 0) {

				} else {
					rowDeletion(rowCount);
				}
				ResultSet rs = Nomination.rsNom;
				int row = 0;
				rs.beforeFirst();
				while (rs.next()) {
					Vector t = new Vector();
					t.addElement((String) " ");
					t.addElement((String) " ");
					t.addElement((String) " ");
					t.addElement((String) " ");
					rows.addElement(t);
					commentTable.addNotify();
					commentTable.setValueAt(rs.getString(1), row, 0);
					commentTable.setValueAt(rs.getDate(2), row, 1);
					commentTable.setValueAt(rs.getString(3), row, 2);
					commentTable.setValueAt(rs.getString(4), row, 3);
					row++;
				}
				System.out.println("row = " + row);
				setRow(row);
			} catch (SQLException e1) {
				e1.printStackTrace();
			}

		}

		public void rowDeletion(int rowno) {
			int rowCount = rowno - 1;
			System.out.println("Row Count is " + rowCount);
			for (int i = rowCount; i >= 0; i--) {
				System.out.println("i = " + i);
				rows.removeElementAt(i);
				commentTable.addNotify();
			}
		}
	}

	class ClickSubmit implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String ObjButtons[] = { "Yes", "No" };
			int PromptResult = 1;

			PromptResult = JOptionPane.showOptionDialog(null,
					"Confirm submission?", "Confirmation Message",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, ObjButtons, ObjButtons[1]);

			if (PromptResult == 0) {
				try {
					String groupName = "Operations";
					String selectedAward = (String) awardListCBox
							.getSelectedItem();
					String nominatedEmpName = (String) voteListCBox
							.getSelectedItem();
					String votedByEmpName = Employee
							.getUserNameEmpName(EmpUserName);
					new Vote(selectedAward, groupName, nominatedEmpName,
							votedByEmpName);

				} catch (SQLException e1) {
					e1.printStackTrace();
				}
				mainWindow.dispose();
				new SwitchBoard();
			}
			foo();
		}
	}

	class ClickCancel implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String ObjButtons[] = { "Yes", "No" };
			int PromptResult = 1;
			PromptResult = JOptionPane.showOptionDialog(null,
					"Are you sure you want to cancel submission?",
					"Confirmation Message", JOptionPane.DEFAULT_OPTION,
					JOptionPane.WARNING_MESSAGE, null, ObjButtons,
					ObjButtons[1]);
			if (PromptResult == 0) {
				mainWindow.dispose();
				new SwitchBoard();
			}
			foo();
		}
	}

	class ClickExit implements ActionListener {
		public void actionPerformed(ActionEvent e) {

			String ObjButtons[] = { "Yes", "No" };
			int PromptResult = 1;
			PromptResult = JOptionPane.showOptionDialog(null,
					"Are you sure you want to log-out?",
					"Confirmation Message", JOptionPane.DEFAULT_OPTION,
					JOptionPane.WARNING_MESSAGE, null, ObjButtons,
					ObjButtons[1]);
			if (PromptResult == 0) {
				System.out
						.println("\n\n"
								+ " ------------------------------------------------------------\n\n"
								+ " THANK YOU FOR USING EMPLOYEES AWARDS SYSTEM VERSION 1.1\n\n"
								+ " ------------------------------------------------------------\n\n"
								+ " Programmer: Diana\n"
								+ " Email Address: dianameilengwong@yahoo.com\n\n"
								+ " Programmer: Michiko\n"
								+ " Email Address: michikochand@yahoo.com\n\n"
								+ " Programmer: Nino\n"
								+ " Email Address: najami@yahoo.com\n\n"
								+ " ------------------------------------------------------------\n"
								+ "\n\n");
				mainWindow.dispose();
				new SwitchBoard();
			}
			foo();
		}
	}

	public void foo() {
		return;
	}

	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub

	}

}
